Loading...
Searching...
No Matches
juce::PixelARGB Class Reference

## Detailed Description

Represents a 32-bit INTERNAL pixel with premultiplied alpha, and can perform compositing operations with it.

This is used internally by the imaging classes.

See also
  PixelRGB

The documentation for this class was generated from the following file:

- juce_graphics/colour/juce_PixelFormats.h

## Public Types

enum | { indexA = 3 , indexR = 0 , indexG = 1 , indexB = 2 }
| The indexes of the different components in the byte layout of this type of colour. More...

## Public Member Functions

| PixelARGB () noexcept=default
| Creates a pixel without defining its colour.
| PixelARGB (uint8 a, uint8 r, uint8 g, uint8 b) noexcept
forcedinline uint32 | getNativeARGB () const noexcept
| Returns a uint32 which represents the pixel in a platform dependent format.
forcedinline uint32 | getInARGBMaskOrder () const noexcept
| Returns a uint32 which will be in argb order as if constructed with the following mask operation ((alpha << 24) | (red << 16) | (green << 8) | blue).
uint32 | getInARGBMemoryOrder () const noexcept
| Returns a uint32 which when written to memory, will be in the order a, r, g, b.
forcedinline uint32 | getEvenBytes () const noexcept
| Return channels with an even index and insert zero bytes between them.
forcedinline uint32 | getOddBytes () const noexcept
| Return channels with an odd index and insert zero bytes between them.
forcedinline uint8 | getAlpha () const noexcept
forcedinline uint8 | getRed () const noexcept
forcedinline uint8 | getGreen () const noexcept
forcedinline uint8 | getBlue () const noexcept
template<class Pixel>
forcedinline void | set (const Pixel &src) noexcept
| Copies another pixel colour over this one.
void | setARGB (uint8 a, uint8 r, uint8 g, uint8 b) noexcept
| Sets the pixel's colour from individual components.
template<class Pixel>
forcedinline void | blend (const Pixel &src) noexcept
| Blends another pixel onto this one.
forcedinline void | blend (PixelRGB src) noexcept
| Blends another pixel onto this one.
template<class Pixel>
forcedinline void | blend (const Pixel &src, uint32 extraAlpha) noexcept
| Blends another pixel onto this one, applying an extra multiplier to its opacity.
template<class Pixel>
forcedinline void | tween (const Pixel &src, uint32 amount) noexcept
| Blends another pixel with this one, creating a colour that is somewhere between the two, as specified by the amount.
forcedinline void | setAlpha (uint8 newAlpha) noexcept
| Replaces the colour's alpha value with another one.
forcedinline void | multiplyAlpha (int multiplier) noexcept
| Multiplies the colour's alpha value with another one.
forcedinline void | multiplyAlpha (float multiplier) noexcept
PixelARGB | getUnpremultiplied () const noexcept
forcedinline void | premultiply () noexcept
| Premultiplies the pixel's RGB values by its alpha.
forcedinline void | unpremultiply () noexcept
| Unpremultiplies the pixel's RGB values.
forcedinline void | desaturate () noexcept

## Member Enums

## anonymous enum

anonymous enum

The indexes of the different components in the byte layout of this type of colour.

Enumerator
indexA |
indexR |
indexG |
indexB |

## Constructors and Destructors

## PixelARGB() [1/2]

juce::PixelARGB::PixelARGB | ( |  | ) |

default noexcept

Creates a pixel without defining its colour.

Referenced by getUnpremultiplied(), and PixelARGB().

## PixelARGB() [2/2]

juce::PixelARGB::PixelARGB | ( | uint8 | a,
|  | uint8 | r,
|  | uint8 | g,
|  | uint8 | b )

inline noexcept

References components, and PixelARGB().

## Member Functions

## getNativeARGB()

forcedinline uint32 juce::PixelARGB::getNativeARGB | ( |  | ) | const

inline noexcept

Returns a uint32 which represents the pixel in a platform dependent format.

References forcedinline, and internal.

Referenced by getInARGBMaskOrder().

## getInARGBMaskOrder()

forcedinline uint32 juce::PixelARGB::getInARGBMaskOrder | ( |  | ) | const

inline noexcept

Returns a uint32 which will be in argb order as if constructed with the following mask operation ((alpha << 24) | (red << 16) | (green << 8) | blue).

References components, forcedinline, and getNativeARGB().

Referenced by getInARGBMemoryOrder().

## getInARGBMemoryOrder()

uint32 juce::PixelARGB::getInARGBMemoryOrder | ( |  | ) | const

inline noexcept

Returns a uint32 which when written to memory, will be in the order a, r, g, b.

In other words, if the return-value is read as a uint8 array then the elements will be in the order of a, r, g, b

References components, and getInARGBMaskOrder().

## getEvenBytes()

forcedinline uint32 juce::PixelARGB::getEvenBytes | ( |  | ) | const

inline noexcept

Return channels with an even index and insert zero bytes between them.

This is useful for blending operations. The exact channels which are returned is platform dependent.

References forcedinline, and internal.

Referenced by blend(), blend(), multiplyAlpha(), and tween().

## getOddBytes()

forcedinline uint32 juce::PixelARGB::getOddBytes | ( |  | ) | const

inline noexcept

Return channels with an odd index and insert zero bytes between them.

This is useful for blending operations. The exact channels which are returned is platform dependent.

References forcedinline, and internal.

Referenced by blend(), blend(), multiplyAlpha(), and tween().

## getAlpha()

forcedinline uint8 juce::PixelARGB::getAlpha | ( |  | ) | const

inline noexcept

References components, and forcedinline.

## getRed()

forcedinline uint8 juce::PixelARGB::getRed | ( |  | ) | const

inline noexcept

References components, and forcedinline.

## getGreen()

forcedinline uint8 juce::PixelARGB::getGreen | ( |  | ) | const

inline noexcept

References components, and forcedinline.

## getBlue()

forcedinline uint8 juce::PixelARGB::getBlue | ( |  | ) | const

inline noexcept

References components, and forcedinline.

## set()

template<class Pixel>

forcedinline void juce::PixelARGB::set | ( | const Pixel & | src | ) |

inline noexcept

Copies another pixel colour over this one.

This doesn't blend it - this colour is simply replaced by the other one.

References forcedinline, and internal.

Referenced by blend().

## setARGB()

void juce::PixelARGB::setARGB | ( | uint8 | a,
|  | uint8 | r,
|  | uint8 | g,
|  | uint8 | b )

inline noexcept

Sets the pixel's colour from individual components.

References components.

## blend() [1/3]

template<class Pixel>

forcedinline void juce::PixelARGB::blend | ( | const Pixel & | src | ) |

inline noexcept

Blends another pixel onto this one.

This takes into account the opacity of the pixel being overlaid, and blends it accordingly.

References juce::clampPixelComponents(), forcedinline, getEvenBytes(), getOddBytes(), internal, and juce::maskPixelComponents().

## blend() [2/3]

forcedinline void juce::PixelARGB::blend | ( | PixelRGB | src | ) |

noexcept

Blends another pixel onto this one.

This takes into account the opacity of the pixel being overlaid, and blends it accordingly.

References forcedinline, and set().

## blend() [3/3]

template<class Pixel>

forcedinline void juce::PixelARGB::blend | ( | const Pixel & | src,
|  | uint32 | extraAlpha )

inline noexcept

Blends another pixel onto this one, applying an extra multiplier to its opacity.

The opacity of the pixel being overlaid is scaled by the extraAlpha factor before being used, so this can blend semi-transparently from a PixelRGB argument.

References juce::clampPixelComponents(), forcedinline, getEvenBytes(), getOddBytes(), internal, and juce::maskPixelComponents().

## tween()

template<class Pixel>

forcedinline void juce::PixelARGB::tween | ( | const Pixel & | src,
|  | uint32 | amount )

inline noexcept

Blends another pixel with this one, creating a colour that is somewhere between the two, as specified by the amount.

References forcedinline, getEvenBytes(), getOddBytes(), and internal.

## setAlpha()

forcedinline void juce::PixelARGB::setAlpha | ( | uint8 | newAlpha | ) |

inline noexcept

Replaces the colour's alpha value with another one.

References components, and forcedinline.

## multiplyAlpha() [1/2]

forcedinline void juce::PixelARGB::multiplyAlpha | ( | int | multiplier | ) |

inline noexcept

Multiplies the colour's alpha value with another one.

References forcedinline, getEvenBytes(), getOddBytes(), and internal.

Referenced by multiplyAlpha().

## multiplyAlpha() [2/2]

forcedinline void juce::PixelARGB::multiplyAlpha | ( | float | multiplier | ) |

inline noexcept

References forcedinline, and multiplyAlpha().

## getUnpremultiplied()

PixelARGB juce::PixelARGB::getUnpremultiplied | ( |  | ) | const

inline noexcept

References internal, PixelARGB(), and unpremultiply().

## premultiply()

forcedinline void juce::PixelARGB::premultiply | ( |  | ) |

inline noexcept

Premultiplies the pixel's RGB values by its alpha.

References components, and forcedinline.

## unpremultiply()

forcedinline void juce::PixelARGB::unpremultiply | ( |  | ) |

inline noexcept

Unpremultiplies the pixel's RGB values.

References components, forcedinline, and juce::jmin().

Referenced by getUnpremultiplied().

## desaturate()

forcedinline void juce::PixelARGB::desaturate | ( |  | ) |

inline noexcept

References components, and forcedinline.

## Member Data Documentation

## internal

uint32 juce::PixelARGB::internal

Referenced by blend(), blend(), getEvenBytes(), getNativeARGB(), getOddBytes(), getUnpremultiplied(), multiplyAlpha(), set(), and tween().

## components

Components juce::PixelARGB::components

Referenced by desaturate(), getAlpha(), getBlue(), getGreen(), getInARGBMaskOrder(), getInARGBMemoryOrder(), getRed(), PixelARGB(), premultiply(), setAlpha(), setARGB(), and unpremultiply().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited